var guxxmail_query_state = false;
var guxxmail_accounts;
var guxxmail_prefs;
var guxxmail_global_accounts;
var guxxmail_timer;
var viewhint = 0;

function set_password_ff3(host,user,pass)
{
	var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
	var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");

	// delete old
	var logins = passwordManager.findLogins({}, host, null, host);
	for (var i=0;i<logins.length;i++)
	{
		passwordManager.removeLogin(logins[i]);
	}

	// create
	var LoginInfo = new nsLoginInfo(host,null,host,user,pass,'','');
	passwordManager.addLogin(LoginInfo);
}

function get_password_ff3(host)
{
	var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

	var logins = passwordManager.findLogins({}, host, null, host);

	if (logins.length==0) return;
	else return {
		host: logins[0].hostname,
		user: logins[0].username,
		password: logins[0].password
	};
}

function set_password_ff2(host,user,pass, olduser)
{
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);

	try
	{
		passwordManager.removeUser(host,olduser);
	}
	catch(err) { }

	passwordManager.addUser(host,user,pass);
}

function get_password_ff2(host)
{
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
	var e=passwordManager.enumerator;

	s=false;

	while (e.hasMoreElements()) 
	{
		pw=e.getNext().QueryInterface(Components.interfaces.nsIPassword);
		if (pw.host==host)
		{
			s=pw;
			break;
		}
	}
	return s;
}

function set_password(host,user,pass, olduser)
{
	if ("@mozilla.org/login-manager;1" in Components.classes)
		return set_password_ff3(host,user,pass);
	else
		return set_password_ff2(host,user,pass,olduser);
}

function get_password(host)
{
	if ("@mozilla.org/login-manager;1" in Components.classes)
		return get_password_ff3(host);
	else
		return get_password_ff2(host);
}

function getProxy()
{
    prefSvc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);

	var i, host, port;

	proxyType = "direct";
	proxyHost = "";
	proxyPort = 0;

	switch(this.prefSvc.getIntPref("network.proxy.type"))
	{
		case 1:
		{
			if (this.prefSvc.getCharPref("network.proxy.socks") != "")
			{
				proxyType = "socks4";
				if (prefSvc.getIntPref("network.proxy.socks_version") == 5) proxyType = "socks5";
				proxyHost = prefSvc.getCharPref("network.proxy.socks");
				proxyPort = prefSvc.getIntPref("network.proxy.socks_port");
			}
			if (this.prefSvc.getCharPref("network.proxy.http") != "")
			{
				proxyType = "http";
				proxyHost = prefSvc.getCharPref("network.proxy.http");
				proxyPort = prefSvc.getIntPref("network.proxy.http_port");
			}
			break;
		}
		case 2:
		case 4:
		{
			try
			{
				var pacs = Components.classes["@mozilla.org/network/proxy-auto-config;1"].getService(Components.interfaces.nsIProxyAutoConfig);
				var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

				var uri = ios.newURI(prefSvc.getCharPref("network.proxy.autoconfig_url"), null, null);
				var res = pacs.getProxyForURI(uri);
				res = res.split(/\s*;\s*/)[0];
				res = res.split(/\s+|:/);

				switch (res[0])
				{
					case "PROXY":
					{
						proxyType = "http";
						proxyHost = res[1];
						proxyPort = res[2];
						break;
					}
					case "SOCKS":
					case "SOCKS4":
					{
						proxyType = "socks4";
						proxyHost = res[1];
						proxyPort = res[2];
						break;
					}
					case "SOCKS5":
					{
						proxyType = "socks5";
						proxyHost = res[1];
						proxyPort = res[2];
						break;
					}
					default:
					{
						proxyType = "direct";
					}
				}
			}
			catch (ex) 
			{
				proxyType = "direct";
			}
			break;
		}
		default:
		{
			proxyType = "direct";
			break;
        }
    }

	if (proxyType == 'direct') return null;

	proxyService	= Components.classes["@mozilla.org/network/protocol-proxy-service;1"].getService  (Components.interfaces.nsIProtocolProxyService);
	proxyInfo 		= proxyService.newProxyInfo(proxyType, proxyHost, proxyPort, 0, 10, null);
	return proxyInfo;
}

function getShellService()
{
	var shell = null;
	try
	{
		shell = Components.classes["@mozilla.org/browser/shell-service;1"].getService(Components.interfaces.nsIShellService);
	} 
	catch (e) 
	{
	}
	return shell;
}

function doAction()
{
	if (guxxmail_global_accounts.prefs.action == 1) OpenDefaultMailClient();
	if (guxxmail_global_accounts.prefs.action == 2) OpenAddress();
}

function OpenDefaultMailClient()
{
	//if ("@mozilla.org/login-manager;1" in Components.classes)
	return _OpenDefaultMailClient_FF3();

	var objShell = getShellService();
	if( objShell )
	{
		var iAppToOpen = Components.interfaces.nsIShellService.APPLICATION_MAIL;
		if(objShell.openApplication)
		{
			objShell.openApplication(iAppToOpen);
		}
		else if (objShell.openPreferredApplication)
		{
			objShell.openPreferredApplication(iAppToOpen);
		}
	}
}

function _ReadString(key)
{
	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
	var branch = preferencesService.getBranch( "extensions.guxxmail." );
	if (branch.prefHasUserValue( key ) )
	{
		return branch.getCharPref(key);
	}
}

function _OpenDefaultMailClient_FF3()
{
	var path = _ReadString("mailclient");
	if (!path) path = "C:\\Programme\\Mozilla Thunderbird\\thunderbird.exe";
        var targetFile=Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        targetFile.initWithPath(path);
        targetFile.launch();
}

function OpenAddress()
{
	var oNewTab = getBrowser().addTab(guxxmail_global_accounts.prefs.address);
	getBrowser().selectedTab = oNewTab;
	
}

function testcallback(count)
{
		var strbundle = document.getElementById("guxx_strings");

		if (count)
		{
        		alert(strbundle.getString("strConnectionSuccessful")+"\n\n" + count + " "+ strbundle.getString("strMessages"));
		}
		else
		{
			alert(strbundle.getString("strConnectionError"));
		}
		guxxmail_query_state = false;
}

function playSound()
{
	var sound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
	sound.playSystemSound("_moz_mailbeep");
}

var AccountsConsts = 
{
	Pop3 :
	{
		AccountName			: 'POP3',
		StateStart			: 0,
		StateUserName		: 1,
		StatePassword		: 2,
		StateStatus			: 3,
		StateQuit			: 4,
		
		DefaultPort			: 110,
		DefaultSSLPort			: 995,
		
		CommandOKPrefix		: '+OK',
		CommandERRPrefix	: '-ERR'
	},

	IMAP :
	{
		AccountName			: 'IMAP',
		StateStart			: 0,
		StateUserName		: 1,
		StateStatus			: 2,
		StateQuit			: 3,
		
		DefaultPort			: 143,
		DefaultSSLPort			: 993,
		
		CommandOKPrefix		: 'OK',
		CommandERRPrefix	: 'NO'
	},

	GMail : 
	{
		FeedURL				: 'https://mail.google.com/mail/feed/atom',
		AccountName			: 'GMAIL'
	}
}

function GetMostRecentBrowserWindow()
{
	var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
	var objRecentBrowserWindow = objWindowsManager.getMostRecentWindow('navigator:browser');
	return objRecentBrowserWindow;
}

function BeginsWith(str, pref) 
{
	return str.substring(0, pref.length).toUpperCase() == pref.toUpperCase();
}

function isArray(obj) 
{
	if (obj == null || obj == false) return false;
	if (obj.constructor.toString().indexOf("Array") == -1) return false;
	else return true;
}

function MailAccount(strName, strMailURL, strEMail, strPassword)
{
	this.Name 		= 	strName;
	this.EMail		=	strEMail;
	this.Password	=	strPassword;
	this.MailURL	=	strMailURL;
	this.MailCount 	=	0;
	this.MailCountOld = 0;
	this.MailError  =	false;
	
	this.UserName	= '';
	
	this.Init = function()
	{
		this.UserName = this.EMail;
	}
	
	this.SetMailCount = function(iCount)
	{
		this.MailError = true;
		if (iCount)
		{
			this.MailError = false;
			if (iCount != this.MailCount)
			{
				this.MailCount = iCount;
			}
		}
	}	

	this.GetMailCount = function()
	{
		if (this.MailCount) return this.MailCount;
		return 0;
	}	
	
	this.GetNewMailCount = function()
	{
		if ((this.MailCount - this.MailCountOld) > 0)
		{
			iNewMailCount = this.MailCount - this.MailCountOld;
			this.MailCountOld = this.MailCount;
			return iNewMailCount;
		}
		this.MailCountOld = this.MailCount;
		return 0;
	}
	
	this.Init();
}


function Pop3Account(strName, strUserName, strPassword, strServerURL, iPort, encryption)
{
	this.Name			= strName;
	this.MailAccount	= null; 
	this.Server			= strServerURL;
	this.Port			= iPort;
	this.encryption			= encryption;
	
	if(!this.Port)
	{
		this.Port = AccountsConsts.Pop3.DefaultPort;
	}

	this.InitAccount = function(strEMail, strPassword)
	{
		this.MailAccount = new MailAccount(this.Name, this.Server, strUserName, strPassword);
	};

	this.GetNewMessagesCount = function(objCallBackNewMessagesFunction)
	{
		var objWindow = GetMostRecentBrowserWindow();
		if(objWindow)
		{
			Pop3AccountManager.Start(	this.MailAccount.MailURL,
										this.MailAccount.EMail,
										this.MailAccount.Password,
										this.Port,
										objCallBackNewMessagesFunction,
										this.encryption);
		}
	}

	this.InitAccount(strUserName, strPassword);
}

var Pop3AccountManager = 
{
	UserName			: null,
	Password			: null,
	
	InputStream			: null,
	OutputStream		: null,
	
	CallBack			: null,

	EndOfLine			: "\r\n",
									
	NewMessages			: null,
	
	Start : function(strServerURL, strUserName, strPassword, iPort, objCallBackFunction, encryption)
	{
		this.UserName	= strUserName;
		this.Password	= strPassword;
		this.CallBack	= objCallBackFunction;
		this.encryption	= encryption;

		var objTransportSocket = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);

		if (this.encryption=='ssl')
		{
			var objTransport 	= objTransportSocket.createTransport(['ssl'], 1, strServerURL, iPort, getProxy());
		}
		else
		{
			var objTransport 	= objTransportSocket.createTransport(null, 0, strServerURL, iPort, getProxy());
		}

		objTransport.setTimeout(Components.interfaces.nsISocketTransport.TIMEOUT_CONNECT, 5);
		objTransport.setTimeout(Components.interfaces.nsISocketTransport.TIMEOUT_READ_WRITE, 20);
		this.OutputStream	= objTransport.openOutputStream(Components.interfaces.nsITransport.OPEN_BLOCKING, 4096, -1);

		var objStream		= objTransport.openInputStream(0, 0, 0);
		this.InputStream	= Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		this.InputStream.init(objStream);
		
		var objPump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
		objPump.init(objStream, -1, -1, 0, 0, false);
		objPump.asyncRead(this.Listener,null);
	},
	
	Finish : function()
	{
		this.InputStream.close();
		this.OutputStream.close();
		this.CallBack(this.NewMessages);	
	},
	
	Listener : 
	{
		onStartRequest: function(request, context)
		{
			Pop3AccountManager.NewMessages	=	AccountsConsts.LOGIN_FAILED;
			Pop3AccountManager.Pop3Commands.State = AccountsConsts.Pop3.StateStart;
		},
		onStopRequest: function(request, context, status)
		{
			Pop3AccountManager.Finish();
		},
		onDataAvailable: function(request, context, inputStream, offset, count)
		{
			var strData = Pop3AccountManager.InputStream.read(count);
			Pop3AccountManager.Pop3Commands.Execute(strData);
		}
	},
	
	Pop3Commands : 
	{	
		State			: null,
		CMD	  			: '',
		
		Execute : function(strData)
		{
			if(BeginsWith(strData, AccountsConsts.Pop3.CommandOKPrefix))
			{
				if(this.State == AccountsConsts.Pop3.StateStatus)
				{
					this.ParseStatus(strData);
				}
				this.State++;
				switch(this.State)
				{
					case AccountsConsts.Pop3.StateUserName:
						this.UserName();
						break;
					case AccountsConsts.Pop3.StatePassword:
						this.Password();
						break;
					case AccountsConsts.Pop3.StateStatus:
						this.Status();
						break;
					case AccountsConsts.Pop3.StateQuit:
						this.Quit();
						break;
				}
			}
			else if (BeginsWith(strData, AccountsConsts.Pop3.CommandERRPrefix))
			{
				this.Quit();
			}
		},
		
		UserName : function()
		{
			this.CMD = 'USER ' + Pop3AccountManager.UserName + Pop3AccountManager.EndOfLine;
			this.RequestData();
		},
		Password : function()
		{
			this.CMD = 'PASS ' + Pop3AccountManager.Password + Pop3AccountManager.EndOfLine;
			this.RequestData();
		},
		Status	: function()
		{
			this.CMD = 'STAT' + Pop3AccountManager.EndOfLine;
			this.RequestData();
		},
		Quit	: function()
		{
			this.CMD = 'QUIT' + Pop3AccountManager.EndOfLine;
			this.RequestData();
		},
		
		RequestData : function()
		{
			Pop3AccountManager.OutputStream.write(this.CMD,this.CMD.length);	
		},
		
		ParseStatus : function(strData)
		{
			var arrMessages = strData.split(' ');
			
			var iNewMessages = 0;
			if(arrMessages[1])
			{
				var iNewMessages = arrMessages[1];
			}
			Pop3AccountManager.NewMessages = iNewMessages;
		}
	}	
}


// IMAP Support

function IMAPAccount(strName, strUserName, strPassword, strServerURL, iPort, encryption)
{
	this.Name			= strName;
	this.MailAccount	= null; 
	this.Server			= strServerURL;
	this.Port			= iPort;
	this.encryption			= encryption
	
	if(!this.Port)
	{
		this.Port = AccountsConsts.IMAP.DefaultPort;
	}

	this.InitAccount = function(strEMail, strPassword)
	{
		this.MailAccount = new MailAccount(this.Name, this.Server, strUserName, strPassword);
	};

	this.GetNewMessagesCount = function(objCallBackNewMessagesFunction)
	{
		var objWindow = GetMostRecentBrowserWindow();
		if(objWindow)
		{
			IMAPAccountManager.Start(	this.MailAccount.MailURL,
										this.MailAccount.EMail,
										this.MailAccount.Password,
										this.Port,
										objCallBackNewMessagesFunction,
										this.encryption);
		}
	}
	
	this.InitAccount(strUserName, strPassword);
}

var IMAPAccountManager = 
{
	UserName			: null,
	Password			: null,
	
	InputStream			: null,
	OutputStream		: null,
	
	CallBack			: null,

	EndOfLine			: "\r\n",
									
	NewMessages			: null,
	
	Start : function(strServerURL, strUserName, strPassword, iPort, objCallBackFunction, encryption)
	{
		this.UserName	= strUserName;
		this.Password	= strPassword;
		this.CallBack	= objCallBackFunction;
		this.encryption	= encryption;

		var objTransportSocket = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);

		if (this.encryption=='ssl')
		{
			var objTransport 	= objTransportSocket.createTransport(['ssl'], 1, strServerURL, iPort, getProxy());
		}
		else
		{
			var objTransport 	= objTransportSocket.createTransport(null, 0, strServerURL, iPort, getProxy());
		}

		objTransport.setTimeout(Components.interfaces.nsISocketTransport.TIMEOUT_CONNECT, 5);
		objTransport.setTimeout(Components.interfaces.nsISocketTransport.TIMEOUT_READ_WRITE, 20);
		this.OutputStream	= objTransport.openOutputStream(Components.interfaces.nsITransport.OPEN_BLOCKING, 4096, -1);

		var objStream		= objTransport.openInputStream(0, 0, 0);
		this.InputStream	= Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		this.InputStream.init(objStream);
		
		var objPump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
		objPump.init(objStream, -1, -1, 0, 0, false);
		objPump.asyncRead(this.Listener,null);
	},
	
	Finish : function()
	{
		this.InputStream.close();
		this.OutputStream.close();
		this.CallBack(this.NewMessages);	
	},
	
	Listener : 
	{
		onStartRequest: function(request, context)
		{
			IMAPAccountManager.IMAPCommands.strBuffer = "";
			IMAPAccountManager.NewMessages	=	AccountsConsts.LOGIN_FAILED;
			IMAPAccountManager.IMAPCommands.State = AccountsConsts.IMAP.StateStart;
		},
		onStopRequest: function(request, context, status)
		{
			IMAPAccountManager.Finish();
		},
		onDataAvailable: function(request, context, inputStream, offset, count)
		{
			var strData = IMAPAccountManager.InputStream.read(count);
			IMAPAccountManager.IMAPCommands.Execute(strData);
		}
	},
	
	IMAPCommands : 
	{	
		State			: null,
		CMD	  			: '',
		strBuffer		: '',
		
		Execute : function(strData)
		{
			commands = strData.split("\r\n");
			command = commands[commands.length - 2];
	
			if(BeginsWith(command, 'a00' + this.State + ' ' + AccountsConsts.IMAP.CommandOKPrefix) || this.State == AccountsConsts.IMAP.StateStart)
			{
				if(this.State == AccountsConsts.IMAP.StateStatus)
				{
					this.ParseStatus(this.strBuffer + strData);
					this.strBuffer = "";
				}
				this.State++;
				switch(this.State)
				{
					case AccountsConsts.IMAP.StateUserName:
						this.Login();
						break;
					case AccountsConsts.IMAP.StateStatus:
						this.Status();
						break;
					case AccountsConsts.IMAP.StateQuit:
						this.Quit();
						break;
				}
			}
			else
			{
				if (BeginsWith(command, 'a00' + this.State + ' ' + AccountsConsts.IMAP.CommandERRPrefix))
				{
					this.Quit();
				}
				this.strBuffer += strData;
			}
		},
		
		Login : function()
		{
			this.CMD = 'a00' + this.State + ' LOGIN ' + IMAPAccountManager.UserName + ' ' + IMAPAccountManager.Password + IMAPAccountManager.EndOfLine;
			this.RequestData();
		},
		Status	: function()
		{
			this.CMD = 'a00' + this.State + ' EXAMINE INBOX' + IMAPAccountManager.EndOfLine;
			this.RequestData();
		},
		Quit	: function()
		{
			this.CMD = 'a00' + this.State + ' LOGOUT' + IMAPAccountManager.EndOfLine;
			this.RequestData();
			this.State = AccountsConsts.IMAP.StateQuit + 1;
			this.strBuffer = "";
		},

		RequestData : function()
		{
			IMAPAccountManager.OutputStream.write(this.CMD,this.CMD.length);	
		},
		
		ParseStatus : function(strData)
		{
			var pattern = /\*\s*([0-9]*)\s*RECENT/i;
			var arrMessages = pattern.exec(strData);
			var iNewMessages = arrMessages[1];
			IMAPAccountManager.NewMessages = iNewMessages;
		}
	}	
}

function GmailAccount(strName, strEMail, strPassword)
{
	this.Name			= strName;
	this.MailAccount 	= null; 
	
	this.InitAccount = function(strEMail, strPassword)
	{
		this.MailAccount = new MailAccount(this.Name, AccountsConsts.GMail.MailURL, strEMail, strPassword);
	};
	
	this.GetNewMessagesCount = function(objCallBackFunction)
	{
		var objServerResponse = function(strData, objRequest)
		{
			var iNewMessagesCount = AccountsConsts.LOGIN_FAILED;

			var parser = new DOMParser();
			var XMLDoc = parser.parseFromString(strData, "text/xml");
		
			var objXMLRoot = XMLDoc.documentElement;
			var objXMLChildNode = null;
			if(objXMLRoot.tagName == "feed")
			{
				for(var i = 0; i < objXMLRoot.childNodes.length; i++)
				{
					objXMLChildNode = objXMLRoot.childNodes[i];
					if(objXMLChildNode.tagName == 'fullcount')
					{
						iNewMessagesCount = objXMLChildNode.childNodes[0].nodeValue;
						break;
					}
				}
			}
			objCallBackFunction(iNewMessagesCount);	
		};
		
		ServerData.ServerRequest(AccountsConsts.GMail.FeedURL,
										'',
										'dummy',
										'dummy',
										null);
		
		ServerData.ServerRequest(AccountsConsts.GMail.FeedURL,
										'',
										this.MailAccount.UserName,
										this.MailAccount.Password,
										objServerResponse);

	};
	
	this.InitAccount(strEMail,strPassword);
}


var ServerData = 
{
	ServerRequest : function(strURL, strPostData, strUserName, strPassword, ServerResponseFunction)
	{
		var objIOService	= Components.classes["@mozilla.org/network/io-service;1"].createInstance(Components.interfaces.nsIIOService);
		var objURI			= objIOService.newURI(strURL, null, null);

		if(strUserName != null && strPassword != null)
		{
			objURI.username		= strUserName;
			objURI.password		= strPassword;
		}
		
		var objChannel		= objIOService.newChannelFromURI(objURI);
		
		objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).setRequestHeader('PRAGMA','NO-CACHE',false);
		objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).setRequestHeader('CACHE-CONTROL','NO-CACHE',false);

		if(strPostData != null) 
		{
			var objUploadStream		= Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
			objUploadStream.setData(strPostData, strPostData.length);

			var objUploadChannel	= objChannel.QueryInterface(Components.interfaces.nsIUploadChannel);
			objUploadChannel.setUploadStream(objUploadStream, "application/x-www-form-urlencoded", -1);

			objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).requestMethod = "POST";
		}
		
		var objObserver = new this.Observer(ServerResponseFunction);
		objChannel.asyncOpen(objObserver, null);
	},
	
	Observer: function(ServerResponseFunction)
	{
		return ({
				Data : "",
				onStartRequest: function(aRequest, aContext)
				{
					this.Data = "";
				},
				onStopRequest: function(aRequest, aContext, aStatus)
				{
					if(ServerResponseFunction)
					{
						ServerResponseFunction(this.Data, aRequest);
					}
				},
				onDataAvailable: function(aRequest, aContext, aStream, aSourceOffset, aLength)
				{
					var objScriptableInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
					objScriptableInputStream.init(aStream);
					this.Data += objScriptableInputStream.read(aLength);
				}
			});
	}
}


function Accounts()
{
	this.lastid = -1;
	
	this.accounts = new Array;

	this.GetAccountList = function()
	{
		return this.accounts;
	},
	this.RemoveAccount = function(id)
	{
		this.accounts[id] = new Array;
		this.lastid = -1;
	},
	
	this.SetAccount = function(
						id,
						accountname,
						account,
						password,
						server,
						port,
						type,
						encryption,
						oldaccount)
	{
		if (id && isArray(this.accounts[id]))
		{
			this.accounts[id] = new Array(
						accountname,
						account,
						password,
						server,
						port,
						type,
						encryption,
						oldaccount);
			this.lastid = -1;
		}
	} 
	this.AddAccount = function(
						accountname,
						account,
						password,
						server,
						port,
						type,
						encryption)
	{
		this.lastid = newid = this.accounts.length;

		this.accounts[newid] = new Array(
						accountname,
						account,
						password,
						server,
						port,
						type,
						encryption,
						account);
	} 
}

function Preferences()
{
	this.address = "";
	this.action = 1;
	this.playsound = false;
	this.showpopup = false;
	this.showtext = true;
	this.checkinterval = false;
	
	if (!this.checkinteval) this.checkinterval = 1;
	
	
	this.ReadAccounts = function()
	{
		this.accounts = new Accounts();
		itemcount = this.ReadInt('itemcount');
		if (!itemcount)		// check for old old version accounts
		{
			var mailserver = this.ReadString('mailserver');
			if (mailserver)
			{
				var username = this.ReadString('username');
				var password = this.ReadString('password');

				var pos = 0;

				set_password('guxxmail://'+pos,username,password, "");
				
				this.SaveString('accounts.accountname.' + pos, username);
//				this.SaveString('accounts.account.' + pos, username);
//				this.SaveString('accounts.password.' + pos, password);
				this.SaveString('accounts.server.' + pos, mailserver);
				this.SaveString('accounts.port.' + pos, 110);
				this.SaveString('accounts.type.' + pos, 'POP3');
				this.SaveString('accounts.encryption.' + pos++, 'none');
				this.SaveInt('itemcount', 1);

				this.RemoveKey('username');
				this.RemoveKey('password');
				this.RemoveKey('mailserver');
				
				itemcount = 1;
			}
		}
		for (i = 0; i < itemcount; i++)
		{
			// check for old version accounts
			if (this.ReadString('accounts.account.' + i))
			{
				username = this.ReadString('accounts.account.' + i);
				password = this.ReadString('accounts.password.' + i);
				set_password('guxxmail://'+i,username,password, "");
				this.RemoveKey('accounts.account.' + i);
				this.RemoveKey('accounts.password.' + i);
				this.SaveString('accounts.encryption.' + i, 'none');
			}

			this.accounts.AddAccount(
				this.ReadString('accounts.accountname.' + i),
//				this.ReadString('accounts.account.' + i),
				get_password('guxxmail://'+i).user,
//				this.ReadString('accounts.password.' + i),
				get_password('guxxmail://'+i).password,
				this.ReadString('accounts.server.' + i),
				this.ReadString('accounts.port.' + i),
				this.ReadString('accounts.type.' + i),
				this.ReadString('accounts.encryption.' + i)
			);
		}
	}
	
	this.SaveAccounts = function()
	{
		itemcount = this.accounts.accounts.length;
		var pos = 0;
		for (i = 0; i < itemcount; i++)
		{
			if (isArray(this.accounts.accounts[i]))
			{
				set_password('guxxmail://'+pos,this.accounts.accounts[i][1],this.accounts.accounts[i][2], this.accounts.accounts[i][7]);
				this.SaveString('accounts.accountname.' + pos, this.accounts.accounts[i][0]);
//				this.SaveString('accounts.account.' + pos, this.accounts.accounts[i][1]);
//				this.SaveString('accounts.password.' + pos, this.accounts.accounts[i][2]);
				this.SaveString('accounts.server.' + pos, this.accounts.accounts[i][3]);
				this.SaveString('accounts.port.' + pos, this.accounts.accounts[i][4]);
				this.SaveString('accounts.type.' + pos, this.accounts.accounts[i][5]);
				this.SaveString('accounts.encryption.' + pos++, this.accounts.accounts[i][6]);
			}
		}
		this.SaveInt('itemcount', pos);		
	}
	
	this.readPrefs = function()
	{
		this.address = this.ReadString('address');
		if (this.address == null) this.address = "";
		this.action = this.ReadInt('action');
		if (this.action == null) this.action = 1;
		this.playsound = this.ReadBool('playsound');
		this.showpopup = this.ReadBool('showpopup');
		this.showtext = this.ReadBool('showtext');
		this.checkinterval = this.ReadInt('checkinterval');
		this.ReadAccounts();
	}
	this.SavePrefs = function()
	{
		this.SaveString('address', this.address);
		this.SaveInt('action', this.action);
		this.SaveBool('playsound', this.playsound);
		this.SaveBool('showpopup', this.showpopup);
		this.SaveBool('showtext', this.showtext);
		this.SaveInt('checkinterval', this.checkinterval);
		this.SaveAccounts();
	}
	
	this.RemoveKey = function(key)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		if (branch.prefHasUserValue( key ) )
		{
			return branch.deleteBranch( key );
		}
		
	}

	this.ReadBool = function(key)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		if (branch.prefHasUserValue( key ) )
		{
			return branch.getBoolPref(key);
		}
	}
	this.SaveBool = function(key, value)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		branch.setBoolPref(key, value);
	}
	this.ReadInt = function(key)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		if (branch.prefHasUserValue( key ) )
		{
			return branch.getIntPref(key);
		}
	}
	this.SaveInt = function(key, value)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		branch.setIntPref(key, value);
	}
	this.ReadString = function(key)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		if (branch.prefHasUserValue( key ) )
		{
			return branch.getCharPref(key);
		}
	}
	this.SaveString = function(key, value)
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.guxxmail." );
		branch.setCharPref(key, value);
	}

	this.readPrefs();
}

var DialogsXULEvents = 
{
	OnLoadDetailSettingsDialog : function(event)
	{
		guxxmail_accounts.lastid = false;

		this.m_editid = m_editid;
		this.type = 'pop3';
		this.accountname = "";
		this.account = "";
		this.password = "";
		this.server = "";
		this.port = "110";
		this.encryption = 'none';
		this.oldaccount = "";	
	
		if (this.m_editid)
		{
			accounts = guxxmail_accounts.GetAccountList();
			if (isArray(accounts[m_editid]))
			{
				viewhint = 0;

				var objTxt = document.getElementById('txtAccountName');
				objTxt.value = this.accountname = accounts[m_editid][0];
				var objTxt = document.getElementById('txtEMail');
				objTxt.value = this.account = accounts[m_editid][1];
				var objTxt = document.getElementById('txtPassword');
				objTxt.value = this.password = accounts[m_editid][2];
				var objServer = document.getElementById('txtMailServer');
				objServer.value = this.server = accounts[m_editid][3];
				var objPort = document.getElementById('txtPort');
				this.oldaccount = accounts[m_editid][7];

				var tp = accounts[m_editid][5];
				var objRadioPOP3		= document.getElementById('radioPop3');
				var objRadioIMAP		= document.getElementById('radioIMAP');
				var objRadioGMAIL		= document.getElementById('radioGMAIL');
				
				objRadioPOP3.setAttribute('selected', 'false');
				objRadioIMAP.setAttribute('selected', 'false');
				objRadioGMAIL.setAttribute('selected', 'false');

				if (tp == 'POP3') { objRadioPOP3.setAttribute('selected', 'true'); this.type = 'pop3'; }
				if (tp == 'IMAP') { objRadioIMAP.setAttribute('selected', 'true'); this.type = 'imap'; }
				if (tp == 'GMAIL') { objRadioGMAIL.setAttribute('selected', 'true'); this.type = 'GMAIL'; objServer.disabled = true; objPort.disabled = true; }
				
				this.encryption =  accounts[m_editid][6];
				var objRadioGroupEn = document.getElementById('radioGroupEn');
				var objRadioEnNone = document.getElementById('radioEnNone');
				var objRadioEnSSL = document.getElementById('radioEnSSL');

				if (this.encryption=='ssl') objRadioGroupEn.selectedItem = objRadioEnSSL;
				else  objRadioGroupEn.selectedItem = objRadioEnNone;

				if (accounts[m_editid][4]) objPort.value = this.port = accounts[m_editid][4];

				this.CheckForTest();
			}
		}
	},
	
	OnUnloadPopupWindow : function(event)
	{
		if (guxxmail_global_accounts)
		{
			guxxmail_global_accounts.prefs.SaveBool('popupopen', false);
		}
	},
	
	OnLoadPopupWindow : function(event)
	{
		if (guxxmail_global_accounts)
		{
			guxxmail_global_accounts.prefs.SaveBool('popupopen', true);
			
			var strbundle = document.getElementById("guxx_strings");
			container = document.getElementById("accounts");
	
			if ( container.hasChildNodes() )
			{
    				while ( container.childNodes.length >= 4 )
	    			{
        				container.removeChild( container.firstChild );       
    				} 
			}

			for (i = 0; i < guxxmail_global_accounts.account.length; i++)
			{
				if (guxxmail_global_accounts.account[i])
				{
					var suffix = "";
					if ( guxxmail_global_accounts.account[i].MailAccount.MailError )
					{
						suffix = ' [' + strbundle.getString("strFailed") + ']';
					}
					else
					{
				 		if (guxxmail_global_accounts.account[i].MailAccount.GetMailCount() > 0) suffix = " [" + guxxmail_global_accounts.account[i].MailAccount.GetMailCount() + " " + strbundle.getString("strNew") + "]";
					}
					var label = document.createElement('label');
					if (!guxxmail_global_accounts.account[i].MailAccount.MailError && guxxmail_global_accounts.account[i].MailAccount.GetMailCount() > 0)
					{
						label.setAttribute('value', guxxmail_global_accounts.account[i].MailAccount.Name + suffix);
						container.insertBefore(label, container.firstChild);
					}
				}
			}
		}
	},
	
	OnSelectAddEditRadioGroupEMails : function(event)
	{
		viewhint++;
		if (viewhint < 2) return;

		var objRadioGroupEMails 	= document.getElementById('radioGroupEMails');
		var objRadioPOP3		= document.getElementById('radioPop3');
		var objRadioIMAP		= document.getElementById('radioIMAP');
		var objRadioGMAIL		= document.getElementById('radioGMAIL');
		
		var objTxtPort			= document.getElementById('txtPort');
		var objTxtServer		= document.getElementById('txtMailServer');
		var objRadioGroupEn		= document.getElementById('radioGroupEn');

		this.encryption = objRadioGroupEn.selectedItem.value;

		ssl = (this.encryption=='ssl');

                objTxtPort.disabled = false;
                objTxtServer.disabled = false;

		if (objRadioGroupEMails.selectedItem == objRadioPOP3)
		{
			this.type = "pop3";
			objTxtPort.value = this.port = (ssl ? AccountsConsts.Pop3.DefaultSSLPort : AccountsConsts.Pop3.DefaultPort);
			objTxtPort.disabled = false;
			objTxtServer.disabled = false;
		}
		if (objRadioGroupEMails.selectedItem == objRadioIMAP)
		{
			this.type = "imap";
			objTxtPort.value = this.port = (ssl ? AccountsConsts.IMAP.DefaultSSLPort : AccountsConsts.IMAP.DefaultPort);
			objTxtPort.disabled = false;
			objTxtServer.disabled = false;
		}
		if (objRadioGroupEMails.selectedItem == objRadioGMAIL)
		{
			this.type = "GMAIL";
			objTxtPort.disabled = true;
			objTxtServer.disabled = true;
		}
		this.CheckForTest();
	},
	
	OnInputAddEditAccountNameTextBox : function(event)
	{
		var objTxt	= document.getElementById('txtAccountName');
		this.accountname = objTxt.value;
		this.CheckForTest();
	},
	OnInputAddEditEmailTextBox : function(event)
	{
		var objTxt	= document.getElementById('txtEMail');
		this.account = objTxt.value;
		this.CheckForTest();
	},
	OnInputAddEditPasswordTextBox : function(event)
	{
		var objTxt	= document.getElementById('txtPassword');
		this.password = objTxt.value;
		this.CheckForTest();
	},
	OnInputAddEditMailServerTextBox : function(event)
	{
		var objTxt	= document.getElementById('txtMailServer');
		this.server = objTxt.value;
		this.CheckForTest();
	},
	OnInputAddEditMailServerPortTextBox : function(event)
	{
		var objTxt	= document.getElementById('txtPort');
		this.port = objTxt.value;
		this.CheckForTest();
	},

	OnCommandAddEditTestAccountButton : function(event)
	{
		switch (this.type)
		{
			case 'pop3':
			{
				if (!guxxmail_query_state)
				{
					account = new Pop3Account('testaccount', this.account, this.password, this.server, this.port, this.encryption);
					guxxmail_query_state = true;
					account.GetNewMessagesCount(testcallback);
				}
				break;
			}
			case 'imap' :
			{
				if (!guxxmail_query_state)
				{
					account = new IMAPAccount('testaccount', this.account, this.password, this.server, this.port, this.encryption);
					guxxmail_query_state = true;
					account.GetNewMessagesCount(testcallback)
				}
				break;
			}
			case 'GMAIL' :
			{
				if (!guxxmail_query_state)
				{
					account = new GmailAccount('testaccount', this.account, this.password);
					guxxmail_query_state = true;
					account.GetNewMessagesCount(testcallback)
				}
				break;
			}
		}
	},

	OnCommandAddEditOKButton : function(event)
	{
		if (this.type == 'pop3') tp = "POP3";
		if (this.type == 'imap') tp = "IMAP";
		if (this.type == 'GMAIL') tp = "GMAIL";
		if (this.m_editid)
		{
			guxxmail_accounts.SetAccount(
						this.m_editid,
						this.accountname,
						this.account,
						this.password,
						this.server,
						this.port,
						tp,
						this.encryption,
						this.oldaccount);
		}
		else
		{
			guxxmail_accounts.AddAccount(
						this.accountname,
						this.account,
						this.password,
						this.server,
						this.port,
						tp,
						this.encryption); 
		}
	},

	CheckForTest : function()
	{
		var objButtonTest	= document.getElementById('btnTestAccount');
		var objButtonOk		= document.getElementById('btnOK');
			
		if (this.type != '' && this.accountname != '' && this.account != '' && this.password != "" && ((this.server != "" && this.port != '') || this.type == 'GMAIL' ))
		{
			objButtonTest.disabled = false;
			objButtonOk.disabled = false;
		}
		else
		{
			objButtonTest.disabled = true;
			objButtonOk.disabled = true;
		}

	},
	
	OnLoadSettingsDialog : function(event)
	{
		guxxmail_prefs = new Preferences();
		guxxmail_accounts = guxxmail_prefs.accounts;
		
		this.setAddress(guxxmail_prefs.address);
		this.setAction(guxxmail_prefs.action);
		this.SetCombo(guxxmail_prefs.checkinterval);
		this.SetPlaySound(guxxmail_prefs.playsound);
		this.SetShowPopup(guxxmail_prefs.showpopup);
		this.SetShowText(guxxmail_prefs.showtext);

		var objWindow = GetMostRecentBrowserWindow();
		this.DisplayAccounts(null, null);
	},
	
	
	setAddress : function(value)
	{
		var objtxtObj = document.getElementById('txtAddress');
		objtxtObj.value = value;
	},
	
	setAction : function (value)
	{
		var otxtAddress = document.getElementById('txtAddress');
		otxtAddress.disabled = true;
		
		if (value == 2) otxtAddress.disabled = false;
		
		var oComboType = document.getElementById('sysAction');
		var oPopupMenu = oComboType.firstChild;
		
		var oMenuItem = null;
		for(var i=0; i< oPopupMenu.childNodes.length; i++)
		{
			oMenuItem = oPopupMenu.childNodes[i];
			if(oMenuItem.getAttribute('id') == value)
			{
				oComboType.selectedItem = oMenuItem;
				break;
			}
		}
	},
	
	OnUnLoadSettingsDialog : function(event)
	{
		var objWindow = GetMostRecentBrowserWindow();
	},
	
	DisplayAccounts : function()
	{
		accounts = guxxmail_accounts.GetAccountList();
		
		for (i = 0; i < accounts.length; i++)
		{
			if (isArray(accounts[i])) this.AddMailAccountTreeItem(i, accounts[i][0], accounts[i][1], this.translateType(accounts[i][5]));
		}
	},

	UpdateMailAccountTreeItem : function(id, strAccountName, strAccountUsername, strAccountType)
	{
		var objSettingsDocument = document;

		var objTreeCellAccountName = objSettingsDocument.getElementById('name_' + id);
		var objTreeCellAccountUsername = objSettingsDocument.getElementById('username_' + id);
		var objTreeCellAccountType = objSettingsDocument.getElementById('type_' + id);

		objTreeCellAccountName.setAttribute('label', strAccountName);
		objTreeCellAccountUsername.setAttribute('label', strAccountUsername);
		objTreeCellAccountType.setAttribute('label', strAccountType);
	},
	
	AddMailAccountTreeItem : function(id, strAccountName, strAccountUsername, strAccountType)
	{
		var objSettingsDocument = document;

		var objTreeChildrenMailAccounts = objSettingsDocument.getElementById('treeChildrenMailAccounts');
		var objTreeItem = objSettingsDocument.createElement('treeitem');
		objTreeItem.setAttribute('id', id);
		var objTreeRow	= objSettingsDocument.createElement('treerow');

		var objTreeCellAccountName = objSettingsDocument.createElement('treecell');
		var objTreeCellAccountUsername = objSettingsDocument.createElement('treecell');
		var objTreeCellAccountType = objSettingsDocument.createElement('treecell');
		
		objTreeCellAccountName.setAttribute('id', 'name_' + id);
		objTreeCellAccountUsername.setAttribute('id', 'username_' + id);
		objTreeCellAccountType.setAttribute('id', 'type_' + id);
		
		objTreeCellAccountName.setAttribute('label', strAccountName);
		objTreeCellAccountUsername.setAttribute('label', strAccountUsername);
		objTreeCellAccountType.setAttribute('label', strAccountType);
		
		objTreeRow.appendChild(objTreeCellAccountName);
		objTreeRow.appendChild(objTreeCellAccountUsername);
		objTreeRow.appendChild(objTreeCellAccountType);
		
		objTreeItem.appendChild(objTreeRow);
		objTreeChildrenMailAccounts.appendChild(objTreeItem);
	},
	
	OnSelectSettingsMailAccountsTree : function(event)
	{
		this.SetSettingsEditDeleteButtonsDisabled(false);
	},
	
	SetSettingsEditDeleteButtonsDisabled : function(isDisabled)
	{
		var objEditButton = document.getElementById('btnEdit');
		var objEditDelete = document.getElementById('btnDelete');
		objEditButton.disabled = isDisabled;	
		objEditDelete.disabled = isDisabled;
	},

	GetSelectedTreeItem : function(objTree)
	{
		var objTreeItem = null;
		var iIndex = objTree.currentIndex;
		if(iIndex != -1)
		{
			objTreeItem = objTree.contentView.getItemAtIndex(iIndex);
		}
		return objTreeItem;
	},

	RemoveMailAccountTreeItem : function(id)
	{
		var objTreeMailAccounts = document.getElementById('treeMailAccounts');
		var objTreeItemToDelete = this.GetSelectedTreeItem(objTreeMailAccounts);
		
		if(objTreeItemToDelete)
		{
			var iDeleteItemIndex = objTreeMailAccounts.currentIndex;
			var objTreeChildrenParent = objTreeItemToDelete.parentNode;
			objTreeChildrenParent.removeChild(objTreeItemToDelete);
			this.SetSettingsEditDeleteButtonsDisabled(true);
		}
	},
	
	GetSelectedID : function()
	{
		var objTreeMailAccounts = document.getElementById('treeMailAccounts');
		if (objTreeMailAccounts.currentIndex != -1)
		{
			var selection = objTreeMailAccounts.contentView.getItemAtIndex( objTreeMailAccounts.currentIndex );
			return selection.getAttribute("id");
		}
		else
		{
			this.SetSettingsEditDeleteButtonsDisabled(true);
		}
		return -1;
	},
	
	OnCommandSettingsEditButton : function(event)
	{
		id = this.GetSelectedID()
		this.ShowDetailedOptionsWindow(id);
	},
	
	OnCommandSettingsDeleteButton : function(event)
	{
		id = this.GetSelectedID()
		guxxmail_accounts.RemoveAccount(id);
		this.RemoveMailAccountTreeItem(id);
	},

	ShowOptionsWindow : function()
	{
		var strOptionsPath	= 'chrome://guxxmail/content/guxxmail_options.xul';
	
		openDialog(strOptionsPath,
									'SETTINGS',
									'modal,centerscreen,chrome,resizable=no',
									null);

	},
	
	ShowDetailedOptionsWindow : function(id)
	{
		var strDetailedOptionsPath	= 'chrome://guxxmail/content/guxxmail_edit_options.xul';
	
		openDialog(strDetailedOptionsPath,
									'DETAILS',
									'modal,centerscreen,chrome,resizable=no',
									id,
									guxxmail_accounts);

		if (id) this.UpdateMailAccountTreeItem(id, guxxmail_accounts.accounts[id][0], guxxmail_accounts.accounts[id][1], this.translateType(guxxmail_accounts.accounts[id][5]));
		else if (guxxmail_accounts.lastid != -1) this.AddMailAccountTreeItem(guxxmail_accounts.lastid, guxxmail_accounts.accounts[guxxmail_accounts.lastid][0], guxxmail_accounts.accounts[guxxmail_accounts.lastid][1], guxxmail_accounts.accounts[guxxmail_accounts.lastid][5]);
	},

	translateType : function(text)
	{
		if (text == "GMAIL") text = "Google-Mail";
		return text;
	},
	
	onCommandSettingsNoaction : function()
	{
		var otxtAddress = document.getElementById('txtAddress');
		guxxmail_prefs.action = 0;
		otxtAddress.disabled = true;
	},
	
	onCommandSettingsSysprog: function()
	{
		var otxtAddress = document.getElementById('txtAddress');
		otxtAddress.disabled = true;
		guxxmail_prefs.action = 1;
	},
	onCommandSettingsOpenAddress: function()
	{
		var otxtAddress = document.getElementById('txtAddress');
		otxtAddress.disabled = false;
		guxxmail_prefs.action = 2;
	},

	OnCommandSettingsAddButton : function (event)
	{
		this.ShowDetailedOptionsWindow(null);
	},
	
	SetCombo : function (iMinutesFromPref)
	{
		var oComboInterval = document.getElementById('CheckInterval');
		var oPopupMenu	   = oComboInterval.firstChild;
		
		var oMenuItem = null;
		for(var i=0; i< oPopupMenu.childNodes.length; i++)
		{
			oMenuItem = oPopupMenu.childNodes[i];
			if(oMenuItem.getAttribute('label') == iMinutesFromPref)
			{
				oComboInterval.selectedItem = oMenuItem;
				break;
			}
		}
	},
	
	GetPlaySound : function()
	{
		var obj = document.getElementById('checkPlaySound');
		return obj.checked;
	},

	GetShowPopup : function()
	{
		var obj = document.getElementById('checkPopup');
		if (obj.checked == 'true') return true;
		return obj.checked;
	},

	GetShowText : function()
	{
		var obj = document.getElementById('checkText');
		if (obj.checked == 'true') return true;
		return obj.checked;
	},

	SetPlaySound : function(value)
	{
		var obj = document.getElementById('checkPlaySound');
		if (value) obj.checked = 'true';
	},

	SetShowPopup : function(value)
	{
		var obj = document.getElementById('checkPopup');
		if (value) obj.checked = 'true';
	},

	SetShowText : function(value)
	{
		var obj = document.getElementById('checkText');
		if (value) obj.checked = 'true';
	},
	
	OnDetailSettingsCancel : function(event)
	{
		guxxmail_accounts.lastid = -1;
	},

	OnCommandSettingsOKButton : function(event)
	{
		var oComboInterval = document.getElementById('CheckInterval');
		var oSelectedMenuItem = oComboInterval.selectedItem;
		var iMinutesValue = oSelectedMenuItem.getAttribute('label');
		
		guxxmail_prefs.checkinterval = iMinutesValue;
		guxxmail_prefs.playsound = this.GetPlaySound();
		guxxmail_prefs.showpopup = this.GetShowPopup();
		guxxmail_prefs.showtext = this.GetShowText();
		guxxmail_prefs.address = document.getElementById('txtAddress').value;
		
		guxxmail_prefs.SavePrefs();
		
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers(null, "guxxmail_changeprefs", "");
	}
}

function showPopup()
{
		lastwin = GetMostRecentBrowserWindow();
		guxxmail_global_accounts.prefs.SaveBool('popupopen', true);
		
		var strPopupPath = 'chrome://guxxmail/content/guxxmail_popup.xul';
	
		lastwin.openDialog(strPopupPath,
									'POPUP',
									'modal,centerscreen,chrome,resizable=no',
									guxxmail_global_accounts);					
}

function accountmanager()
{
	this.prefs = new Preferences();
	this.accounts = this.prefs.accounts;
	
	accountlist = this.accounts.GetAccountList();

	this.accountid = 0;
	this.account = Array();

	for (i = 0; i < accountlist.length; i++)
	{
		if (isArray(accountlist[i]))
		{
			if (
				accountlist[i][1] != '' &&
				accountlist[i][2] != '' &&
				(accountlist[i][3] != '' || accountlist[i][5] == 'GMAIL') &&
				accountlist[i][4] != '' &&
				accountlist[i][5] != '')
			{
				if (accountlist[i][5] == 'POP3') this.account[i] = new Pop3Account(accountlist[i][0], accountlist[i][1], accountlist[i][2], accountlist[i][3], accountlist[i][4], accountlist[i][6]);
				if (accountlist[i][5] == 'IMAP') this.account[i] = new IMAPAccount(accountlist[i][0], accountlist[i][1], accountlist[i][2], accountlist[i][3], accountlist[i][4], accountlist[i][6]);
				if (accountlist[i][5] == 'GMAIL') this.account[i] = new GmailAccount(accountlist[i][0], accountlist[i][1], accountlist[i][2]);
			}
		}
	}
	
	this.query = function()
	{
		guxxmail_query_state = true;		
		this.accountid = 0;
		this.nextaccount();
	}

	this.nextaccount = function()
	{
		if (this.accountid < this.account.length)
		{
			if (this.account[this.accountid]) this.account[this.accountid].GetNewMessagesCount(callback);
		}
		else
		{
			guxxmail_query_state = false;
			guxxmail_display_result();
		}
	}
}

function callback(count)
{
	if (!count)
	{
		if (guxxmail_global_accounts.account[guxxmail_global_accounts.accountid])
		{
			guxxmail_global_accounts.account[guxxmail_global_accounts.accountid].MailAccount.SetMailCount(false);
		}
	}
	else
	{
		if (guxxmail_global_accounts.account[guxxmail_global_accounts.accountid])
		{
			guxxmail_global_accounts.account[guxxmail_global_accounts.accountid].MailAccount.SetMailCount(count);
		}
	}

	guxxmail_global_accounts.accountid++;
	guxxmail_global_accounts.nextaccount();
}

function guxxmail_display_result()
{
	menucontainer = document.getElementById("backpopup");
	
	if ( menucontainer.hasChildNodes() )
	{
    	while ( menucontainer.childNodes.length >= 4 )
    	{
        	menucontainer.removeChild( menucontainer.firstChild );       
    	} 
	}

	var strbundle = document.getElementById("guxx_strings");

	var totalmail = 0;
	var totalnewmail = 0;
	error= 0;
	if (guxxmail_global_accounts)
	{
		for (i = 0; i < guxxmail_global_accounts.account.length; i++)
		{
			if (guxxmail_global_accounts.account[i])
			{
				var suffix = "";
				if ( guxxmail_global_accounts.account[i].MailAccount.MailError )
				{
					suffix = ' [' + strbundle.getString("strFailed") + ']';
				}
				else
				{
				 	if (guxxmail_global_accounts.account[i].MailAccount.GetMailCount() > 0) suffix = " [" + guxxmail_global_accounts.account[i].MailAccount.GetMailCount() + " " + strbundle.getString("strNew") + "]";
				}
				var menuitem = document.createElement('menuitem');
				menuitem.setAttribute('label', guxxmail_global_accounts.account[i].MailAccount.Name + suffix);
				menuitem.setAttribute('class', 'menuitem-iconic');
				menuitem.setAttribute('oncommand', 'doAction();');
				if (guxxmail_global_accounts.account[i].MailAccount.MailError)
				{
					error++;
					menuitem.setAttribute('image', 'chrome://guxxmail/skin/error.png');
				}
				if (!guxxmail_global_accounts.account[i].MailAccount.MailError && guxxmail_global_accounts.account[i].MailAccount.GetMailCount() > 0) menuitem.setAttribute('image', 'chrome://guxxmail/skin/newmail_menu.png');
				menucontainer.insertBefore(menuitem, menucontainer.firstChild);
				totalmail += parseInt(guxxmail_global_accounts.account[i].MailAccount.GetMailCount());
				totalnewmail += parseInt(guxxmail_global_accounts.account[i].MailAccount.GetNewMailCount());
			}		
		}
		var icon = 'chrome://guxxmail/skin/status_mail.png'; 
		if (totalmail > 0)
		{
			if (error > 0)
			{
				icon = 'chrome://guxxmail/skin/status_newmail_error.png';
			}
			else
			{
				icon = 'chrome://guxxmail/skin/status_newmail.png';
			}
		}
		else
		{
			if (error > 0)
			{
				icon = 'chrome://guxxmail/skin/status_mail_error.png';
			}
			else
			{
				icon = 'chrome://guxxmail/skin/status_mail.png';
			}
		}
		var gimage = document.getElementById('guxximage');
		gimage.setAttribute('src', icon);
		
		if (guxxmail_global_accounts.prefs)
		{
			var glabel = document.getElementById('maillabel');
			if (guxxmail_global_accounts.prefs.showtext)
			{
				glabel.setAttribute('hidden', 'false');
				if (totalmail == 0)
				{
					glabel.setAttribute('value', strbundle.getString("strNoNewMails"));
				}
				else
				{
					glabel.setAttribute('value', totalmail + " " + strbundle.getString("strMailsNew"));
				}
			}
			else
			{
				glabel.setAttribute('value', '');
				glabel.setAttribute('hidden', 'true');
			}
			if (guxxmail_global_accounts.prefs.playsound && totalnewmail > 0)
			{
				playSound();
			}
			if (guxxmail_global_accounts.prefs.showpopup && totalnewmail > 0 && totalmail > guxxmail_global_accounts.prefs.ReadInt('lastshown'))
			{
				if (!guxxmail_global_accounts.prefs.ReadBool('popupopen'))
				{
					guxxmail_global_accounts.prefs.SaveInt('lastshown', totalmail);
					showPopup();
				}
			}
			if (totalnewmail < guxxmail_global_accounts.prefs.ReadInt('lastshown'))
			{
				guxxmail_global_accounts.prefs.SaveInt('lastshown', totalmail);
			}
		}
	}
}

var guxxmail_prefs_observer = 
{
	observe: function(subject, topic, data)
	{
		guxxmail_reinit();
  	}
}

function guxxmail_reinit()
{
	clearInterval(guxxmail_timer);


	guxxmail_accounts = null;
	guxxmail_prefs = null;
	guxxmail_global_accounts = null;
	guxxmail_query_state = false;

	guxxmail_global_accounts = new accountmanager();
	guxxmail_global_accounts.prefs.SaveBool('popupopen', false);
	if (!guxxmail_global_accounts.prefs.ReadInt('lastshown')) guxxmail_global_accounts.prefs.SaveInt('lastshown', 0);

	var interval = guxxmail_global_accounts.prefs.checkinterval;
	if (interval > 60) interval = 1;
	if (interval < 1) interval = 1;
	guxxmail_timer = window.setInterval(guxxmail_checkmail, interval * 60000);

	window.setTimeout("guxxmail_global_accounts.query()", 1000);
	
}

function guxxmail_init()
{

	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	observerService.addObserver(guxxmail_prefs_observer, "guxxmail_changeprefs", false);

	guxxmail_reinit();
}

function guxxmail_checkmail()
{
	if (!guxxmail_query_state)
	{
		if (guxxmail_global_accounts) guxxmail_global_accounts.query();
	}
}
